
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _WIN32_WINNT 0x501
#define WIN32_LEAN_AND_MEAN 1
#define UNICODE  1
#define _UNICODE 1
#include <Windows.h>
#define for if(0);else for

//#define USE_NATIVE_API
#include "mem.h"

#include <tchar.h>
#ifdef _DEBUG
#define TRACE	_Trace
#include <stdarg.h>	//va_list
#include <stdio.h>	//_vsnwprintf
static void _Trace(LPCTSTR pszFormat, ...)
{
	va_list argptr;
	va_start(argptr, pszFormat);
	//w(v)sprintf1024ȏԂĂȂ
	TCHAR szBuffer[1024];
	wvsprintf(szBuffer, pszFormat, argptr);
	OutputDebugString(szBuffer);
}
#else	//!_DEBUG
#define TRACE	NOP_FUNCTION
//<winnt.h>
//#ifndef NOP_FUNCTION
//#if (_MSC_VER >= 1210)
//#define NOP_FUNCTION __noop
//#else
//#define NOP_FUNCTION (void)0
//#endif
//#endif
#endif	//_DEBUG

void LoadSettings(HMODULE hModule);

// ExtTextOutW̃rbg}bvLbV
class ETOCache {
private:
	HDC		hdc;
	HBITMAP	hbmp;
	BYTE*	lpPixels;
	SIZE	dibSize;

public:
	ETOCache()
		: hdc(NULL),hbmp(NULL),lpPixels(NULL)
	{
		dibSize.cx = dibSize.cy = 0;
	}

	~ETOCache()
	{
		if(hdc)		DeleteDC(hdc);
		if(hbmp)	DeleteObject(hbmp);
	}

	const SIZE& Size() const
	{
		return dibSize;
	}
	BYTE* GetPixel()
	{
		//Assert(lpPixels != NULL);
		return lpPixels;
	}

	//{̂override.cpp
	HDC CreateDC();
	HBITMAP CreateDIB(int width, int height, BYTE** lplpPixels);
	void FillSolidRect(COLORREF rgb, const RECT* lprc);
};

#include "tlsdata.h"
extern CTlsData<ETOCache> g_Cache;

#include <mmsystem.h>	//mmioFOURCC
#define CREATEPROCESS_MAGIC		mmioFOURCC('G', 'D', 'I', '+')

BOOL IsOSXPorLater();
BOOL IsProcessExcluded();


#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	rettype WINAPI ORIG_##name argtype; \
	rettype WINAPI IMPL_##name argtype;
#include "hooklist.h"
#undef HOOK_DEFINE

//EOF
